<HTML>
<HEAD>
<!-- This HTML file has been created by texi2html 1.54
     from suif1.texi on 28 April 1999 -->

<TITLE>The SUIF Version 1 Library - Finding Exposed References</TITLE>
<link href="suif1_87.html" rel=Next>
<link href="suif1_85.html" rel=Previous>
<link href="suif1_toc.html" rel=ToC>

</HEAD>
<BODY>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_85.html">previous</A>, <A HREF="suif1_87.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
<P><HR><P>


<H2><A NAME="SEC86" HREF="suif1_toc.html#TOC86">Finding Exposed References</A></H2>

<P>
<A NAME="IDX634"></A>
<A NAME="IDX635"></A>
<A NAME="IDX636"></A>
<A NAME="IDX637"></A>
<A NAME="IDX638"></A>
The first step in the cloning process is to scan through the code being
copied to search for references to objects that are not visible in the
destination scope.  The <CODE>tree_node_list</CODE>, <CODE>tree_node</CODE>,
<CODE>operand</CODE>, <CODE>instruction</CODE>, and <CODE>block_symtab</CODE> classes have
<CODE>find_exposed_refs</CODE> methods to perform this operation.  The results
are returned in a <CODE>replacements</CODE> structure by putting the exposed
references in the lists of original objects.  The lists of new objects
are left empty.

</P>
<P>
<A NAME="IDX639"></A>
Besides checking for exposed references in the objects themselves, the
<CODE>find_exposed_refs</CODE> methods also check for references contained in
annotations attached to the objects.  Both flat and structured
annotations are checked, but unregistered annotations are ignored since
they are not copied.  The <CODE>find_annote_refs</CODE> method is used to
check a <CODE>suif_object</CODE> for exposed references.

</P>
<P>
Label symbols are a special case.  Even if a label symbol is visible in
the destination scope, it must be replaced if the label instruction is
to be cloned.  Otherwise, there would be two label instructions sharing
the same label symbol!  Thus, the <CODE>find_exposed_refs</CODE> method adds
the symbol in a label instruction to the list of exposed references.
The exception to this is that label symbols that are defined within
cloned symbol tables will automatically be replaced and are not included
in the exposed references.

</P>

<P><HR><P>
<p>Go to the <A HREF="suif1_1.html">first</A>, <A HREF="suif1_85.html">previous</A>, <A HREF="suif1_87.html">next</A>, <A HREF="suif1_113.html">last</A> section, <A HREF="suif1_toc.html">table of contents</A>.
</BODY>
</HTML>
